
/*******************************************************************

   	Macro:       dups;
   	Author:      Harry Droogendyk        harry@stratia.ca
   	Date:        2008/07/12

   	Macro for lazy typist to find duplicates within BY groups

/*******************************************************************/

data a;
	j = 'a'; k = 1; m = 1; output;
	j = 'a'; k = 1; m = 2; output;
	j = 'a'; k = 1; m = 3; output;
	j = 'a'; k = 2; m = 4; output;
	j = 'b'; k = 2; m = 5; output;
	j = 'b'; k = 2; m = 6; output;
run;

data b;
	set a;
	  by j k;

	put j=  k=  first.j=  last.j=  first.k=  last.k= ;
run;

%macro dups(v);
	if not ( first.&v and last.&v )
%mend;

data dups;
	set a;
	 by j k;

	%dups(k);
run;

proc sort data = a	
			out = b
			dupout = c nodupkey;
	by i;
run;
